

import plot
from optimization import evaluator
from optimization import grid_search
from optimization import formula_search
from signal_generation import generator
from trace_checker import STL





def evaluate_signals(formula, folder_name, sf_base, sfc, th_list=None):
  stn = STL.SyntaxTreeNode()
  stn.initialize_node(formula.split(), 0)

  # TODO: for each signal, evaluate along the formula, store the results
  # for i in xrange(len(signal_files)):
  avg = 0
  # or i in xrange(sfc):
  i = sfc
  s_file_name = (sf_base + "_%d") % i
  t, signal= plot.read_into_arrays(folder_name + s_file_name)
  t, label = plot.read_into_arrays(folder_name + s_file_name + "_label")

  result = stn.compute_along_signal(signal, t)
  binary_result = [x > 0 for x in result]
  plot.plot_with_evaluation(signal, label, t, i, result, binary_result, th_list)
  t = 0
  # plot.title(formula)
  file_name = folder_name + formula + ".png"
  plot.save(file_name)
  print file_name




  for l,r in zip(label, result):
    if (r >= 0 and l > 0) or (r < 0 and l == 0):
      t +=1
  avg += (float(t))/len(label)
  # avg = avg / sfc
  print "Average " + str(avg)


def evaluate_signals2(formula, folder_name, sf_base, sfc):

  count = 0
  total = 0
  for i in xrange(sfc):
    s_file_name = (sf_base + "_%d") % i
    s_file = folder_name + s_file_name
    label_file =  folder_name + s_file_name + "_label"
    r = evaluator.evaluate(formula, s_file, label_file, None, return_type=0, mismatch_count_bound=0)
    count += 1
    total += r
    print r

  print 'AVERAGE: ' + str(total/count)
  # TODO GRID SEARCH OVER THE PARAMETERS
  # WHEN MISMATCH OCCURS GATHER INFORMATION, INCREASE P1 DECREASE P2 etc --> if that allows us to find
  # the optimal formula faster than grid search EUREKA ...... -> RV or CPS week


def plot_for_paper():
  folder_name = 'test_data/gauss_test_all_formulas/'
  signal_file_base = 'sgt'
  trace_count = 1

  formula = "x0 > 48" # mismatch 32104
  evaluate_signals(formula, folder_name, signal_file_base, trace_count, [48])
  plot.show()

  formula = "A 0 72 ( x0 > 16 )" # 2577
  prefix_formula = STL.infix_to_prefix(formula)
  evaluate_signals(prefix_formula, folder_name, signal_file_base, trace_count, [16])
  plot.show()

  formula = "( x0 > 20 ) & ( A 0 72 ( x0 > 16 ) )"
  prefix_formula = STL.infix_to_prefix(formula)
  evaluate_signals(prefix_formula, folder_name, signal_file_base, trace_count, [16])
  plot.show()


def main():

  #
  # folder_name = '/sasdata/stl_opt/gauss_test_only_A/'
  folder_name = 'test_data/push_test/'
  signal_file_base = 'sgt'
  trace_count = 10
  pc = 4

  # to generate
  # generator.generate_signals_push(folder_name, signal_file_base, trace_count, pc)
  
  # to optimize
  formula = 'P 0 10 x0 > 15'
  formula = '( x0 < 1 & x1 > 15 )'
  formula = '( x1 > 10 ) & ( x0 < 1 )'
  prefix_formula = STL.infix_to_prefix(formula)
  evaluate_signals(prefix_formula, folder_name, signal_file_base, 2)
  plot.show()
  return
  formula = 'P 0 pa x0 > px'

  parameter_list = ['pa', 'px']
  parameter_domain = [range(20,80,4), range(10,50,4)]
  result_file = folder_name + 'test_result_P_greater_than.mat'
  best_v, params, all_results, time_passed = grid_search.grid_search(
    formula, parameter_list, parameter_domain, folder_name, signal_file_base, trace_count, '', pc)
  all_results_converted = plot.convert_save_results(parameter_list, parameter_domain, all_results, result_file, formula,
                                                    time_passed, trace_count, pc, best_v, params)
  print best_v
  print params

  optimized_formula = formula
  optimized_formula = optimized_formula.replace('pa', str(params[0]))
  optimized_formula = optimized_formula.replace('px', str(params[1]))
  evaluate_signals(optimized_formula, folder_name, signal_file_base, 10)




def search_all_formulas():


  # folder_name = '/sasdata/stl_opt/gaus_test_formula_search/'
  # folder_name = 'test_data/gauss_test_all_formulas/'
  folder_name = 'test_data/push_test/'

  signal_file_base = 'sgt'
  trace_count = 10
  pc = 4
  operator_counts = [0, ]
  # #parameter_domains = {'px': xrange(10,50,4), 'pA': xrange(20, 80, 4), 'pP': xrange(20, 100, 4), 'pS': xrange(20, 80, 4)}
  # parameter_domains = {'p0': xrange(10,40,20), 'pA': xrange(20, 80, 10), 'pP': xrange(20, 80, 10), 'pS': xrange(20, 80, 10)}
  # result_file = 'min_max'
  # metric_list = ['0']

  #
  parameter_domains = {'p0': xrange(0,2,1), 'p1': xrange(6,32,2), 'pA': xrange(20, 80, 10), 'pP': xrange(20, 80, 10), 'pS': xrange(20, 80, 10)}
  result_file = 'min_max'
  metric_list = ['0', '1']

  results, best_formulas = formula_search.formula_search(metric_list, operator_counts, parameter_domains, folder_name, trace_count,
                                                         False, signal_file_base, pc, True, return_type=1,
                                                         result_file=result_file)

  formula = best_formulas[len(best_formulas)-1].formula
  formula_prefix = STL.infix_to_prefix(formula)
  print formula
  return best_formulas
  # evaluate_signals(formula_prefix, folder_name, signal_file_base, 4)
  # evaluate_signals(formula_prefix, folder_name, signal_file_base, 4)
  #print best_formulas

def show_results(formulas):
  folder_name = 'test_data/gauss_test_all_formulas/'
  signal_file_base = 'sgt'
  # folder_name = 'test_data/push_test/'

  for _, formula in formulas.iteritems():
    #formula = 'A 0 68 ( ( p > 14 ) S 0 76 ( p > 30 ) )'
    formula_prefix = STL.infix_to_prefix(formula.formula)
    print formula
    print formula_prefix
    evaluate_signals(formula_prefix, folder_name, signal_file_base, 3)
  plot.show()

    #formula = 'A 0 72 ( p > 18 )'
  #formula_prefix = STL.infix_to_prefix(formula)
  #evaluate_signals(formula_prefix, folder_name, signal_file_base, 5)

if __name__ == '__main__':
  formulas = search_all_formulas()
  show_results(formulas)
  # plot_for_paper()
  # main()
