

import trace_checker.STL as STL


def evaluate(formula, signal_file_name, label_file_name, stn, return_type, mismatch_count_bound):
  """

  formula: A String, prefix formula
  signal_file: A String
  label_file: A String
  return_type: 0 or 1,
  mismatch_count_bound: An integer
  """

  # Construct syntax tree
  if not stn:
    stn = STL.SyntaxTreeNode()
    stn.initialize_node(formula.split(), 0)
  else:
    stn.clean()

  result = 0
  counter = 0

  skip_count = 10 # skip the first 10 data points, not important in monitoring.
  sc = 0

  with open(signal_file_name, 'r') as sf, open(label_file_name, 'r') as lf:
    for ts, te in zip(sf, lf):
      s = ts.split()
      t = s[0]
      s = s[1:]
      _, e = te.split()
      t = float(t)
      s = [float(x) for x in s]
      e = float(e)
      while t > stn.nt:
        stn.compute_qv(STL.DataPoint(value=sp, time=stn.nt))
        if sc > skip_count:
          result += ( stn.qv > 0 ) == ep
          counter += 1
        else:
          sc+=1

      stn.compute_qv(STL.DataPoint(time=t, value=s))
      if sc > skip_count:
        result += ( stn.qv > 0 ) == e
        counter += 1
      else:
        sc += 1
      #if return_type==1 and counter - result > mismatch_count_bound:
      #  break
      sp  = s
      ep = e

  if return_type == 0:
    return float(result)/counter
  if return_type == 1: # return the mismatch count
    return counter - result
















