
import sg
import os
from multiprocessing import Pool
import json
from functools import partial



def generate_signals_push(folder_name, file_name, trace_count, pc=8):
  # ["duration", "violate", "min_v_dur", "max_v_dur", "v_dur", "min_step", "max_step"]
  options = sg.Options(duration=2000, violate=1, min_v_dur=50, v_dur=70, max_v_dur=100, min_step=1, max_step=5,
                       sleep=0, s_min=0, s_max=100, t=0)

  # Check if the directory exists, create if necessary:
  if not os.path.isdir(folder_name):
    os.mkdir(folder_name)

  # Store the options:
  j = json.dumps(options._asdict())
  with open(folder_name + "options.txt", 'w') as outfile:
    json.dump(j, outfile)

  partial_generator = partial(sg.signal_generator, folder_name=folder_name, name=file_name, s_type="PUSH",
                              options=options, additional_options=None)

  pool = Pool(processes=pc)
  pool.map(partial_generator, range(trace_count))


  pool.close()
  pool.join()

def generate_signals(folder_name, file_name, trace_count, pc=8):
  # ["duration", "violate", "min_v_dur", "max_v_dur", "v_dur", "min_step", "max_step"]
  options = sg.Options(duration=2000, violate=1, min_v_dur=50, v_dur=70, max_v_dur=250, min_step=1, max_step=5,
                       sleep=0, s_min=0, s_max=100, t=0)
  gauss_options = sg.GaussOptions(mean=15, deviation=6, v_diff=20)

  # Check if the directory exists, create if necessary:
  if not os.path.isdir(folder_name):
    os.mkdir(folder_name)

  # Store the options:
  j = json.dumps(options._asdict())
  with open(folder_name + "options.txt", 'w') as outfile:
    json.dump(j, outfile)

  j = json.dumps(gauss_options._asdict())
  with open(folder_name + "s_options.txt", 'w') as outfile:
    json.dump(j, outfile)

  partial_generator = partial(sg.signal_generator, folder_name=folder_name, name=file_name, s_type="GAUSS",
                              options=options, additional_options=gauss_options)

  pool = Pool(processes=pc)
  pool.map(partial_generator, range(trace_count))


  pool.close()
  pool.join()